Contest Link Official Editorial

A - Sum and Product

Given are integers \(S\) and \(P\) . Is there a pair of positive integers \((N,M)\) such that \(N+M=S\) and \(N×M=P\) ?

Solution

签到题。 \(1e9\) 不能直接枚举,那么就枚举 \(P\) 较小的约数即可。

Code

//Author: RingweEH
S=read(); P=read(); ll lim=sqrt(P);
for ( ll i=1; i<=lim; i++ )
{
if ( P%i ) continue;
ll j=P/i;
if ( (i+j)==S ) { printf( "Yes\n" ); return 0; }
}
printf( "No\n" );

B - Abbreviate Fox

Given is a string \(S\) of length \(N\) consisting of lowercase English letters. Snuke can do this operation any number of times: remove fox occurring as a substring from \(s\) and concatenate the remaining parts of \(s\) .

What is the minimum possible length of \(s\) after some number of operations by Snuke?

Solution

我是乱搞过的……不知道 WA+TLE 了多少发。具体就是由于新出现的 fox 只能在删掉的地方,所以考虑每次删掉一个就把两边的搞一遍。

然后再加了个暴力捡漏??


正解:令 \(t\) 初始为一个空串,然后重复下面的步骤直到 \(s\) 为空串:

  • 把 \(s\) 的第一个字符移动到 \(t\) 的末尾,如果 \(t\) 的末尾出现 fox 那么删除掉并计入答案。

妙啊。

Code

//Author: RingweEH
//乱搞代码
int check( int pos )
{
if ( s[pos]=='f' ) return 1;
if ( s[pos]=='o' ) return 2;
if ( s[pos]=='x' ) return 3;
return 0;
} int repos( int l,int r )
{
while ( 1 )
{
if ( l<0 || r>=n ) return r;
if ( vis[l] || vis[r] ) return r;
int cl=check(l),cr=check(r);
if ( !cl || !cr ) return r;
if ( (cl!=2) && (cr!=2) ) return r;
if ( (cl==2) && (cr==2) ) return r;
if ( cl==2 )
{
if ( (l==0) || vis[l-1] ) return r;
l--; cl=check(l);
if ( cl!=1 ) return r;
if ( cr!=3 ) return r;
cnt++; vis[l]=1; vis[l+1]=1; vis[r]=1; l--; r++;
}
if ( cr==2 )
{
if ( (r>=(n-1)) || vis[r+1] ) return r;
r++; cr=check(r);
if ( cr!=3 ) return r-1;
if ( cl!=1 ) return r-1;
cnt++; vis[l]=1; vis[r-1]=1; vis[r]=1; l--; r++;
}
}
} int main()
{
n=read(); cin>>s; //scanf( "%s",s ); memset( vis,0,sizeof(vis) );
for ( int i=0; i<n-2; i++ )
{
if ( vis[i] ) continue;
if ( (s[i]=='f') && (s[i+1]=='o') && (s[i+2]=='x') )
{
cnt++; vis[i]=1; vis[i+1]=1; vis[i+2]=1; i=repos( i-1,i+3 )-1;
}
}
string s2="";
for ( int i=0; i<n; i++ )
if ( !vis[i] ) s2=s2+s[i];
while( s2.find("fox")!=-1 )
{
s2.erase( s2.find("fox"),3 ); n -= 3;
} printf( "%d",n-cnt*3 );
}

C - Keep Graph Connected

Given is an undirected connected graph with \(N\) vertices numbered 11 to \(N\), and \(M\) edges numbered \(1\) to \(M\) . The given graph may contain multi-edges but not self loops.

Each edge has an integer label between \(1\) and \(N\) (inclusive). Edge \(i\) has a label \(c_i\) , and it connects Vertex \(u_i\) and \(v_i\) bidirectionally.

Snuke will write an integer between \(1\) and \(N\) (inclusive) on each vertex (multiple vertices may have the same integer written on them) and then keep only the edges satisfying the condition below, removing the other edges.

Condition: Let \(x\) and \(y\) be the integers written on the vertices that are the endpoints of the edge. Exactly one of \(x\) and \(y\) equals the label of the edge.

We call a way of writing integers on the vertices good if (and only if) the graph is still connected after removing the edges not satisfying the condition above. Determine whether a good way of writing integers exists, and present one such way if it exists.

Solution

先在图上求一棵生成树,然后构造。如果不存在生成树就无解。

设点 \(1\) 为根,任意涂色,然后向下 \(\text{dfs}\) 。对于一条边 \((u,v,w)\) ,如果 \(tag[x]==w\) 那么给 \(v\) 任意涂色,否则 \(tag[v]=w\) ,这样即可构造出合法解。

Code

为什么把 add( read(),read(),read() ) 改成 u=read(),v=read(),w=read(),add( u,v,w ); 就 Accepted 了啊……没明白诶。

哦,它是函数啊,那没事了。

//Author: RingweEH
void dfs( int u )
{
for ( int i=head[u]; i; i=e[i].nxt )
{
int v=e[i].to;
if ( !tag[v] )
{
if ( tag[u]==e[i].val ) tag[v]= ( tag[u]==1 ) ? 2 : 1;
else tag[v]=e[i].val;
dfs( v );
}
}
}

D - AB

Given are an integer \(N\) and four characters \(cAA\) , \(cAB\) , \(cBA\) and \(cBB\) . Here, it is guaranteed that each of those four characters is A or B.

Snuke has a string \(s\) , which is initially AB.

Let \(|s|\) denote the length of \(s\). Snuke can do the four kinds of operations below zero or more times in any order:

  1. Choose \(i\) such that \(1≤i<|s|\) , \(s_i\) = A, \(s_{i+1}\) = A and insert \(cAA\) between the \(i\)-th and \((i+1)\)-th characters of \(s\) .
  2. Choose \(i\) such that \(1≤i<|s|\) , \(s_i\) = A, \(s_{i+1}\) = B and insert \(cAB\) between the \(i\)-th and \((i+1)\)-th characters of \(s\).
  3. Choose \(i\) such that \(1≤i<|s|\) , \(s_i\) = B, \(s_{i+1}\) = A and insert \(cBA\) between the \(i\)-th and \((i+1)\)-th characters of \(s\).
  4. Choose \(i\) such that \(1≤i<|s|\) , \(s_i\) = B, \(s_{i+1}\) = B and insert \(cBB\) between the \(i\)-th and \((i+1)\)-th characters of \(s\).

Find the number, modulo \((10^9+7)\) , of strings that can be \(s\) when Snuke has done the operations so that the length of \(s\) becomes \(N\) .

Solution

发现只有 4 种变化,一共16种情况。可以大力分讨一下。

  • \(cAB=A,cAA=A\) ,最终答案一定是 \(AAAAA...B\) ,答案就是1.
  • \(cAB=A,cAA=B,cBA=A\) ,发现:开头是 \(A\) ,结尾是 \(AB\) ,没有连续的 \(B\) . 那么就是 \(A....AB\) ,中间是不含连续 \(0\) 的 \(01\) 串,就是斐波那契数列的 \(n-2\) 项。
  • \(cAB=A,cAA=B,cBA=B\) ,发现开头是 \(A\) ,结尾是 \(BB\) ,答案就是 \(2^{n-3}\) .
  • \(cAB=B,cBB=B\) ,答案一定是 \(ABB...B\) ,为 1.
  • \(cAB=B,cBB=A,cBA=A\) ,答案是 \(2^{n-3}\) .
  • \(cAB=B,cBB=A,cBA=B\) ,答案是 \(fib(n-2)\)

Code

//Author: RingweEH
void power()
{
int b=n-3,res=1;
for ( int i=1; i<=b; i++ )
res=res*2%mod;
printf( "%d\n",res );
} void fib()
{
int b=n-3,a1=1,a2=1;
for ( int i=1; i<=b; i++ )
{
int tmp=(a1+a2)%mod;
a1=a2; a2=tmp;
}
printf( "%d\n",a2 );
}

E - Random IS

There are \(N\) isu - chairs in Japanese - arranged from left to right. The \(i\)-th chair from the left has the ID number \(a_i\) . Here, it is guaranteed that \(a_i\) are distinct.

Snuke has decided to mark some of the chairs and throw away the rest. Initially, no chair is marked. We call a choice of marked chairs good when the IDs of the marked chairs are monotonically increasing from left to right.

Snuke has decided to do the following procedure to mark chairs:

  1. We say a chair \(x\) to be nice if (and only if) the choice of marked chairs is still good when \(x\) gets marked. Let \(k\) be the current number of nice chairs.
  2. If \(k=0\) , remove the unmarked chairs and terminate the procedure. Otherwise, choose one from the \(k\) nice chairs with equal probability, mark it, and go back to Step 1.

It can be proved that the expected value of the number of chairs that remain at the end of the procedure is a rational number. Let this value be \(P/Q\) , an irreducible fraction. Additionally, let \(M=10^9+7\) . Then, we can prove that there uniquely exists an integer \(R\) between \(0\) and \(M−1\) (inclusive) such that \(P≡Q×R(modM)\) , and that value equals \(P×Q−1(modM)\) , where \(Q−1\) is the modular multiplicative inverse of \(Q\). Find \(R\) .


定义大小为 \(n\) 的排列 \(a\) 的一个子序列 \(b\) 是好的当且仅当 \(b\) 递增,对于 \(a\) 的子序列 \(b\) 而言,定义一个数 \(i\) 是好的当且仅当 \(a_i\) 加入 \(b\) 后 \(b\) 仍然递增,现在给定 \(n\) 和排列 \(a\) ,你有一个 \(a\) 的子序列 \(b\) ,初始为空,每次操作你会在所有好的数中选择等概率随机一个好的数 \(i\) 并将 \(a_i\) 加入 \(b\) ,询问期望操作次数。

\(1≤n≤2000\) 。

Solution

一开始根本没看懂题

首先在两边补充两个点 \(a_0=0,a_{n+1}=n+1\) .

令 \(f[i][j]\) 表示只考虑 \((i,j)\) 的元素且钦定选了 \(a[i],a[j]\) 的期望个数。那么答案就就是 \(f[0][n+1]\) .

考虑枚举中间第一次选了 \(a[k](a[i]<a[k]<a[j])\) .

显然,易知两边的区间是独立的,期望值可以直接相加,那么有:

\[f[i][j]=1+\dfrac{1}{cnt}\sum_{k=1}^{cnt}(f[i][k]+f[k][j])
\]

其中 \(cnt\) 为满足 \(a[i]<a[k]<a[j]\) 的 \(k\) 的个数。特殊地,如果 \(cnt=0\) 那么 \(f[i][j]=0\) .

由此,我们可以分别考虑 \(\sum_kf[i][k]\) 和 \(\sum_kf[k][j]\) .发现这个东西其实是对称的,那么就只需要计算对于每个 \((i,j)\) ,满足 \(a[k]<a[j]\) 的 \(f[i][k]\) 之和即可。用树状数组维护。对 \(cnt\) 的计算可以使用二维前缀和。

时间复杂度 \(\mathcal{O}(N^2logN)\) .

Code

//Author: RingweEH
void add( int *arr,int pos,int val )
{
for ( ; pos<=n; pos+=lowbit(pos) )
arr[pos]=(arr[pos]+val)%mod;
} int query( int *arr,int pos )
{
int res=0;
for ( ; pos; pos-=lowbit(pos) )
res=(res+arr[pos])%mod;
return res;
} int main()
{
n=read();
for ( int i=1; i<=n; i++ )
{
for ( int j=1; j<=n; j++ )
s[i][j]=s[i-1][j];
a[i]=read();
for ( int j=a[i]; j<=n; j++ )
s[i][j]++;
} inv[1]=1;
for ( int i=2; i<=n; i++ )
inv[i]=(ll)(mod-mod/i)*inv[mod%i]%mod;
a[0]=0; a[n+1]=n+1;
for ( int k=2; k<=n+2; k++ )
{
for ( int i=0; i+k<=n+1; i++ )
{
int j=i+k;
if ( a[i]>a[j] ) continue;
int cnt=s[j-1][a[j]-1]-s[j-1][a[i]]-s[i][a[j]-1]+s[i][a[i]];
if ( !cnt ) continue;
int val=((ll)(query(tr1[i],a[j]-1)+query(tr2[j],n-a[i]))*inv[cnt]+1)%mod;
if ( j<=n ) add( tr1[i],a[j],val );
if ( i>=1 ) add( tr2[j],n-a[i]+1,val );
if ( i==0 && j==n+1 ) printf( "%d\n",val );
}
}
}

F - Paint Tree

Given is a tree with \(N\) vertices numbered \(1\) to \(N\), and \(N−1\) edges numbered \(1\) to \(N−1\) . Edge \(i\) connects Vertex \(a_i\) and \(b_i\) bidirectionally and has a length of \(1\) .

Snuke will paint each vertex white or black. The niceness of a way of painting the graph is \(max(X,Y)\) , where \(X\) is the maximum among the distances between white vertices, and \(Y\) is the maximum among the distances between black vertices. Here, if there is no vertex of one color, we consider the maximum among the distances between vertices of that color to be \(0\) .

There are \(2^N\) ways of painting the graph. Compute the sum of the nicenesses of all those ways, modulo \((10^9+7)\) .

Solution

所以题意就是求所有染色方案下白色直径和黑色直径中较大值的和。

考虑一条直径,设两端为 \(u_1,u_2\) ,并钦定 \(u_1=black\) .

如果两点颜色相同则贡献为 \(dis[u_1][u_2]\times 2^{N-2}\) 。

如果不同,易知答案一定是 \(u_1,v\) 或者 \(u_2,v\) 之间的距离。( \(v\) 为任意点)

记 \(dis[i][0]\) 为 \(i\) 到 \(u_1\) 的距离,\(dis[i][1]\) 为 \(i\) 到 \(u_2\) 的距离。最终答案就是 \(\sum\max(dis[i][0],dis[i][1])\)

考虑枚举这个最大值,尝试求出 “存在多少方案所选的最大值不大于这个数”,记为 \(f[i]\) .

那么有

\[f[i]=\prod_{j=1}^n(\sum_{k=0}^1[dis[j][k]]\leq i)
\]

如果存在某一对 \(dis[i][0],dis[i][1]\) 均大于 \(i\) ,那么 \(f[i]=0\) . 处理了这种特殊情况后,再令 \(g[i]=\max(dis[i][0],dis[i][1])\) ,有

\[f[i]=\prod_{j=1}^n([g[j]\leq i]+1)
\]

直接对 \(g\) 排序,然后扫一遍即可得到 \(f[i]\) .

最终答案等于

\[2(\sum_{i=1}^D(f[i]-f[i-1])\times i+D\times 2^{n-2})
\]

其中 \(D\) 为直径长度。

Code

//Author: RingweEH
void dfs( ll u,ll fa )
{
dep[u]=dep[fa]+1;
for ( ll v : gg[u] )
if ( v!=fa ) dfs( v,u );
} int main()
{
n=read();
for ( ll i=1,u,v; i<n; i++ )
u=read(),v=read(),gg[u].push_back(v),gg[v].push_back(u); //---------------------beginning-------------------------
dep[0]=-1; dfs( 1,0 );
ll u1=-1,mx=0;
for ( ll i=1; i<=n; i++ )
if ( dep[i]>mx ) mx=dep[i],u1=i;
dfs( u1,0 );
for ( ll i=1; i<=n; i++ )
dis1[i]=dep[i];
ll u2=-1; mx=0;
for ( ll i=1; i<=n; i++ )
if ( dep[i]>mx ) mx=dep[i],u2=i;
dfs( u2,0 );
for ( ll i=1; i<=n; i++ )
dis2[i]=dep[i];
//------------------------diameter---------------------------
ll gcnt=0;
for ( ll i=1; i<=n; i++ )
if ( i!=u1 && i!=u2 ) g[++gcnt]=max( dis1[i],dis2[i] );
sort( g+1,g+1+gcnt ); ll lim=0;
for ( ll i=1; i<=n; i++ )
lim=max( lim,min(dis1[i],dis2[i]) );
//-----------------------get_g---------------------------------
for ( ll i=mx; i>=lim; i-- )
{
while ( gcnt>=1 && g[gcnt]>i ) gcnt--;
f[i]=power(2,gcnt);
}
//----------------------get_f----------------------------------
ll tmp=0,ans=0;
for ( ll i=lim; i<=mx; i++ )
{
f[i]=((f[i]-tmp)%mod+mod)%mod;
tmp=(tmp+f[i])%mod;
ans=(ans+f[i]*i)%mod;
}
ans=(ans+mx*power(2,n-2) )%mod;
//--------------------get_ans----------------------------- printf( "%lld",ans*2%mod );
}

最新文章

  1. 你知道C#中的Lambda表达式的演化过程吗?
  2. 正则匹配闭合HTML标签(支持嵌套)
  3. webpack 打包一个简单react组件
  4. 转-HttpClient4.3 连接管理
  5. iOS 7.1耗电严重解决办法
  6. asp.net 图片下载
  7. 过滤html字符的方法
  8. Java 反射的基本应用
  9. bootstrap轮播图--兼容IE7
  10. codeforces Round 286# problem A. Mr. Kitayuta&#39;s Gift
  11. pair work-Elevator Schedule附加题
  12. SPRING IN ACTION 第4版笔记-第七章Advanced Spring MVC-002- 在xml中引用Java配置文件,声明DispatcherServlet、ContextLoaderListener
  13. Visual Studio 单元测试之六---UI界面测试
  14. ios-贝塞尔曲线
  15. Missing number - 寻找缺失的那个数字
  16. php自带验证邮箱 url ip函数
  17. Python爬虫第二天
  18. Spring @Resource,@Autowired,@Qualifier的注解注入和区别
  19. [模板][P3808]AC自动机(简单版)
  20. java 线程(六)死锁

热门文章

  1. TP5 RCE
  2. 高性能arm运行ceph存储基准测试
  3. 想要看懂鸿蒙OS源码?朱老师带你从框架分析开始
  4. CentOS 6.10 安装mysql
  5. ERP应收应付进阶操作与子流程--开源软件诞生29
  6. 如何在Visio 中插入各种数学公式?
  7. 几分钟看懂EasyRecovery数据恢复原理,比我想象的简单易懂得多
  8. 在FL Studio中制作和优化人声和弦(Vocal Chords)
  9. web文件上传漏洞
  10. Codeforces Round #674 (Div. 3) C、D 题解